package com.fr.plugin.xx.ltqc.auth.conf;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.StringUtils;


/**
 * @author xx
 * @since 2021/12/04
 */
@Visualization(category = "门户集成")
@EnableMetrics
public class AuthSsoConfig extends DefaultConfiguration {

    private static volatile AuthSsoConfig config = null;

    public static AuthSsoConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(AuthSsoConfig.class);
        }
        return config;
    }

    @Identifier(value = "debugSwitch", name = "插件调试开关", description = "日志调试模式", status = Status.SHOW)
    private Conf<Boolean> debugSwitch = Holders.simple(true);

    @Identifier(value = "cookieKey", name = "cookie键值", description = "cookie键值", status = Status.SHOW)
    private Conf<String> cookieKey = Holders.simple("VDPUAT");

    @Identifier(value = "validateUrl", name = "校验地址", description = "校验地址", status = Status.SHOW)
    private Conf<String> validateUrl = Holders.simple("");

    @Identifier(value = "loginUrl", name = "登录接口地址", description = "登录接口地址", status = Status.SHOW)
    private Conf<String> envUrl = Holders.simple("");

    public Boolean getDebugSwitch() {
        return this.debugSwitch.get();
    }

    public void setDebugSwitch(Boolean debugSwitch) {
        this.debugSwitch.set(debugSwitch);
    }

    public String getCookieKey() {
        return cookieKey.get();
    }

    public void setCookieKey(String cookieKey) {
        this.cookieKey.set(cookieKey);
    }

    public String getValidateUrl() {
        return validateUrl.get();
    }

    public void setValidateUrl(String validateUrl) {
        this.validateUrl.set(validateUrl);
    }

    public String getEnvUrl() {
        return envUrl.get();
    }

    public void setEnvUrl(String envUrl) {
        this.envUrl.set(envUrl);
    }


    @Override
    public Object clone() throws CloneNotSupportedException {
        AuthSsoConfig cloned = (AuthSsoConfig) super.clone();
        cloned.debugSwitch = (Conf<Boolean>) debugSwitch.clone();
        cloned.cookieKey = (Conf<String>) cookieKey.clone();
        cloned.validateUrl = (Conf<String>) validateUrl.clone();
        cloned.envUrl = (Conf<String>) envUrl.clone();
        return cloned;
    }


    public boolean isConfiged() {
        return StringUtils.isNotBlank(cookieKey.get()) && StringUtils.isNotBlank(validateUrl.get());
    }
}
