package com.fr.plugin.xx.ltqc.auth.handler;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.io.utils.ResourceIOUtils;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.xx.ltqc.auth.Constants;
import com.fr.third.guava.io.Files;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;

/**
 * @Author xx
 * @Date 2022/2/13
 * @Description
 **/
public class CptListHandler extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/cpt/list";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest request, HttpServletResponse response) throws Exception {
        JSONObject object = new JSONObject();
        JSONArray path = getLetPath(Constants.ROOT);
        object.put("state", 0);
        object.put("data", path);
        response.setContentType("application/json; charset=UTF-8");
        WebUtils.printAsJSON(response, object);
    }

    private JSONArray getLetPath(String path) {
        JSONArray array = new JSONArray();
        String[] list = ResourceIOUtils.list(path);
        for (String name : list) {
            String curr = path + File.separator + name;
            if (ResourceIOUtils.isDirectory(curr)) {
                JSONArray childPath = getLetPath(curr);
                if (childPath != null || childPath.length() != 0) {
                    for (int i = 0; i < childPath.length(); i++) {
                        array.put(childPath.getJSONObject(i));
                    }
                }
            } else if ("cpt,frm".contains(Files.getFileExtension(curr))) {
                array.put(JSONObject.create().put("path", curr.replace(Constants.ROOT, "")));
            }
        }
        return array;
    }
}
