package com.fr.plugin.xx.ltqc.auth.handler;

import com.fr.decision.authority.AuthorityContext;
import com.fr.decision.authority.data.CustomRole;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.decision.webservice.v10.user.CustomRoleService;
import com.fr.json.JSONObject;
import com.fr.plugin.xx.ltqc.auth.action.RolePathAuthService;
import com.fr.plugin.xx.ltqc.auth.utils.LogUtils;
import com.fr.stable.StringUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @Author xx
 * @Date 2022/2/13
 * @Description
 **/
public class DelRoleHandler extends BaseHttpHandler {

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/auth/delRole";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) {
        try {
            res.setContentType("application/json; charset=UTF-8");
            String role = WebUtils.getHTTPRequestParameter(req, "role");
            CustomRole customRoles = AuthorityContext.getInstance().getCustomRoleController().getById(role);
            if (StringUtils.isBlank(role)) {
                WebUtils.printAsJSON(res, error("role is not null"));
                return;
            }
            if (customRoles == null) {
                WebUtils.printAsJSON(res, error(String.format("role %s not exist", role)));
                return;
            }
            CustomRoleService.getInstance().deleteCustomRole(role);
            RolePathAuthService.delete(role);
            WebUtils.printAsJSON(res, JSONObject.create().put("state", 0));
        } catch (Exception e) {
            LogUtils.error(e.getMessage(), e);
            try {
                WebUtils.printAsJSON(res, error(e.getMessage()));
            } catch (Exception ex) {
                LogUtils.error(ex.getMessage(), ex);
            }
        }
    }

    private JSONObject error(String mess) {
        return JSONObject.create().put("state", 1).put("mess", mess);
    }

}
